-- Demonstration script for the presentation "Improving SQL Server Performance by Writing Faster T-SQL" by Andy Novick
-- Copyright (C) 2012-2014 by Andrew Novick,
-- This script is intended for demonstration purposes only. Do not use this in production situations.
SELECT database_id
    , DB_NAME(database_id) [db]
	, OBJECT_SCHEMA_NAME([Object_id], database_id) [schema]
    , OBJECT_NAME([OBJECT_ID], database_id) [procedure]
	, SUM(execution_count) execution_count
	, CONVERT(NUMERIC(18,3), (CONVERT(FLOAT, SUM(total_elapsed_time)) / SUM(execution_count)/1000000.0)) avg_duration_sec
	, CONVERT(NUMERIC(18,3), (CONVERT(FLOAT, SUM(total_worker_time)) / SUM(execution_count)/1000000.0)) avg_worker_time_sec
	, CONVERT(bigint,  CONVERT(FLOAT, SUM(total_physical_reads)) / SUM(execution_count)) avg_physical_reads_per_exec
	, CONVERT(bigint, CONVERT(FLOAT,SUM(total_logical_reads))/ SUM(execution_count)) avg_logical_reads_per_exec
	, CONVERT(bigint, CONVERT(FLOAT,SUM(total_logical_writes))/ SUM(execution_count)) avg_logical_writes_per_exe
FROM sys.dm_exec_procedure_stats eps
WHERE DB_NAME(database_id) IS NOT NULL
  AND database_id =2 or database_id>4 and database_id<32767 -- not system database
GROUP BY database_id, object_id, OBJECT_NAME(object_id) 
ORDER BY  avg_duration_sec desc
GO -- >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>